#!/usr/bin/perl
#--------------------------------------------------------------------
# SORT (sort.pl) Ver 1.0a
# 2000/09/26 Hashimoto Zenko
#                zenko@zenko3.com  http://www.zenko3.com/
#
#   `    sort.pl <key>... (wkdir=<Directory>) (dup=delete)
#                                                (sum=<sum>...)
#       <key> : Jn,,(ASC or DESC)
#                        JnA 1`
#                        ASC()l
#                        ex)  3,5 10,2,desc
#           (wkdir=<Directory>) : ƗpfBNg
#                                 ȗ̓JgfBNg
#           (dup=delete) : dA1R[ĥݏo
#                          o͂ FIFO(ŏ̃R[ho)
#                          ȗ́ASo
#           (sum=<sum>) : Wvw
#           <sum> : Jn,
#           dup=sum=͓ws
#   ߂l : 0 - , 10 - Error, 255 - ̑error
#   STDIN  : ̓f[^
#   STDOUT : o̓f[^(sort)
#--------------------------------------------------------------------

$sep = "\\";         # fBNg؋L
$me = "[sort.pl]";
@key_start  = ();    # key Jn̔z
@key_length = ();    # key ̔z
@key_desc   = ();    # key ~ۂ̔z
$wkdir      = "";    # ƗpfBNg
$dup_delete = 0;     # d폜
$exist_sum  = 0;     # Wvw
@sum_start  = ();    # sum Jn̔z
@sum_length = ();    # sum ̔z
@in_key     = ();    # ̓f[^̃L[l̔z
$wkfile = '~sort.tmp';    # Ɨpt@C
$addr_len = 15;

$InCnt  = 0;
$OutCnt = 0;
$DelCnt = 0;

warn $me." Start ".&Now."\n";

#-- `FbN --
if ( &CheckArg() ) { exit 10; }

#-- ̓f[^̃L[lzɊi[ and ̓f[^Ɨpt@Cɏo --
open( WKFILE, ">".$wkdir.$wkfile ) || die "Can't Open for output : $wkdir.$wkfile : $!\n";
$addr = tell( WKFILE );
while ( $inrec = <STDIN> ) {
	$InCnt++;
	chomp( $inrec );

#	-- L[̕ҏW
	$edit_key = "";
	for ( $i = 0; $i <= $#key_start; $i++ ) {
		$edit_key1 = sprintf( "%-$key_length[$i]\s", substr( $inrec, $key_start[$i] - 1, $key_length[$i] ) );
		if ( $key_desc[$i] ) { $edit_key .= ( ~ $edit_key1 ); }
		else                 { $edit_key .= $edit_key1;       }
	}
	push( @in_key, $edit_key.sprintf( "%0$addr_len.0f", $addr ) );

#	-- Ɨpt@Cɓ̓f[^i[
	print WKFILE "$inrec\n";

	$addr = tell( WKFILE );
}
close( WKFILE );

#-- L[Sort --
@sorted_key = sort( @in_key );

#-- SortʂAƗpt@Co --
open( WKFILE, $wkdir.$wkfile ) || die "Can't Open for input : $wkdir.$wkfile : $!\n";
$prev_key = "";
foreach $edit_key ( @sorted_key ) {
	$edit_key1 = substr( $edit_key, 0, length( $edit_key ) - $addr_len );
	if ( $dup_delete ) {
		if ( $edit_key1 eq $prev_key ) {
			$DelCnt++;
			next;
		}
	}

	$addr = substr( $edit_key, length( $edit_key ) - $addr_len );
	seek( WKFILE, $addr, 0 );
	$inrec = <WKFILE>;

	if ( $exist_sum ) {
		if ( $edit_key1 eq $prev_key ) {
			for ( $i = 0; $i <= $#sum_start; $i++ ) {
				$sum[$i] += substr( $inrec, $sum_start[$i] - 1, $sum_length[$i] );
			}
		}
		else {
			if ( $prev_key ne "" ) {
				&EditSumRec();
				print "$outrec";
				$OutCnt++;
			}
			$prev_key = $edit_key1;

			$outrec = $inrec;
			for ( $i = 0; $i <= $#sum_start; $i++ ) {
				$sum[$i] = substr( $inrec, $sum_start[$i] - 1, $sum_length[$i] );
			}
		}
	}

	else {
		print "$inrec";
		$OutCnt++;
		$prev_key = $edit_key1;
	}
}
if ( $exist_sum && $prev_key ne "" ) {
	&EditSumRec();
	print "$outrec";
	$OutCnt++;
}
close( WKFILE );
unlink($wkdir.$wkfile);

printf( STDERR "$me Input  Count = %10d\n", $InCnt );
printf( STDERR "$me Output Count = %10d\n", $OutCnt );
if ( $dup_delete ) { printf( STDERR "$me Delete Count = %10d\n", $DelCnt ); }

warn $me." End   ".&Now."\n";

exit 0;

#--------------------------------------------------------------------
# `FbN
#   `    $ret = &CheckArg();
#   ߂l  0 - , 1 - Error
#   l    keyl @key_start, @key_length, @key_desc Ɋi[
#           ƗpfBNg $wkdir Ɋi[
#           dup=delete w̗L $dup_delete Ɋi[
#           sum= w̗L $exist_sum Ɋi[
#           sum= ̓e @sum_start, @sum_length Ɋi[
#--------------------------------------------------------------------
sub CheckArg {
	$exist_key   = 0;
	$exist_wkdir = 0;

#	-- `FbN --
	if ( $#ARGV < 0 ) {
		warn "$me Requires an Argument\n";
		return 1;
	}

#	-- Ẍ̃`FbN --
	foreach $arg ( @ARGV ) {
#		-- d폜w̌Ɉ͎włȂ
		if ( $dup_delete ) {
			warn "$me Can't write arguments after DUP=DELETE\n";
			return 1;
		}

		$arg = &TRim( $arg );           # Trim

#		-- d폜w --
		if ( $arg =~ /^DUP=DELETE$/i ) {
#			-- WvwƓwłȂ
			if ( $exist_sum ) {
				warn "$me Can't define DUP=DELETE and SUM= at same time\n";
				return 1;
			}
			$dup_delete = 1;
		}

#		-- Wvw --
		elsif ( $arg =~ /^SUM=/i ) {
#			-- d폜wƓwłȂ
			if ( $dup_delete ) {
				warn "$me Can't define DUP= and SUM= at same time\n";
				return 1;
			}
			$exist_sum = 1;
			$sum_temp = $arg;
			$sum_temp =~ s/^SUM=//i;
			@split_arg = split(/,/, $sum_temp);  # J}ɂ؂蕪
#			-- ؂蕪̌`FbN --
			if ( $#split_arg != 1 ) {
				warn "$me SUM= Definition Error\n";
				return 1;
			}
#			-- JnȂÓ`FbN --
			$split_arg[0] = &TRim( $split_arg[0] );
			$split_arg[1] = &TRim( $split_arg[1] );
			if ( $split_arg[0] !~ /^[0-9]+$/ ||
				 $split_arg[1] !~ /^[0-9]+$/ ||
				 $split_arg[0] == 0 || $split_arg[1] == 0 ) {
				warn "$me SUM= Definition Error\n";
				return 1;
			}
			push(@sum_start, $split_arg[0]);    # Jn
			push(@sum_length, $split_arg[1]);   # 
		}

#		-- ƗpfBNgw --
		elsif ( $arg =~ /^WKDIR=/i ) {
#			-- ƗpfBNgw͏dwłȂ
			if ( $exist_wkdir ) {
				warn "$me Duplicate definition : WKDIR\n";
				return 1;
			}
			$exist_wkdir = 1;
			$wkdir = $arg;
			$wkdir =~ s/^WKDIR=//i;
			if ( ! $wkdir ) { $wkdir = "."; }
			$wkdir .= $sep if ( $wkdir !~ /$sep$/ );
		}

#		-- Keyw --
		else {
#			-- ̎w̌ɂ͎włȂ
			if ( $exist_wkdir || $dup_delete || $exist_sum ) {
				warn "$me Can't define Key after other definition\n";
				return 1;
			}

			$exist_key = 1;
			@split_arg = split(/,/, $arg);  # J}ɂ؂蕪
#			-- ؂蕪̌`FbN --
			if ( $#split_arg < 1 || $#split_arg > 2 ) {
				warn "$me Sort Key Definition Error\n";
				return 1;
			}
#			-- JnȂÓ`FbN --
			$split_arg[0] = &TRim( $split_arg[0] );
			$split_arg[1] = &TRim( $split_arg[1] );
			if ( $split_arg[0] !~ /^[0-9]+$/ ||
				 $split_arg[1] !~ /^[0-9]+$/ ||
				 $split_arg[0] == 0 || $split_arg[1] == 0 ) {
				warn "$me Sort Key Definition Error\n";
				return 1;
			}
			push(@key_start, $split_arg[0]);    # Jn
			push(@key_length, $split_arg[1]);   # 

#			-- Sort̑Ó`FbN --
			if    ( $#split_arg < 2 )            { push(@key_desc, 0); }
			elsif ( $split_arg[2] =~ /^ASC$/i  ) { push(@key_desc, 0); }
			elsif ( $split_arg[2] =~ /^DESC$/i ) { push(@key_desc, 1); }
			else {
				warn "$me Sort Key Definition Error\n";
				return 1;
			}
		}
		
	}

#	-- Key` --
	if ( ! $exist_key ) {
		warn "$me Requires Key Definition\n";
		return 1;
	}
#	-- ƗpfBNg` --
	if ( ! $exist_wkdir ) { $wkdir = ".".$sep; }

	return 0;
}
#--------------------------------------------------------------------
# WvR[hҏW
#   `    &EditSumRec();
#   l    $outrec  @sum ̓e𔽉f
#--------------------------------------------------------------------
sub EditSumRec {
	for ( $i = 0; $i <= $#sum_start; $i++ ) {
		$wk = $outrec;
		if ( $sum_start[$i] > 1 ) {
			$outrec = substr( $wk, 0, $sum_start[$i] - 1 );
		}
		else { $outrec = ""; }
		if ( length( $sum[$i] ) <= $sum_length[$i] ) {
			$outrec .= sprintf( "%$sum_length[$i].0f", $sum[$i] );
		}
		else {
			$outrec .= substr( sprintf( "%$sum_length[$i].0f", $sum[$i] ), length( $sum[$i] ) - $sum_length[$i] );
		}
		$outrec .= substr( $wk, $sum_start[$i] - 1 + $sum_length[$i] );
	}
}

#--------------------------------------------------------------------
# O󔒍폜
#   `    $result = &TRim( $string );
#       $string : in  : ͕
#   ߂l  O󔒂菜
#--------------------------------------------------------------------
sub TRim {
	local ( $string ) = @_;

	$string =~ s/^[ @]*//;
	$string =~ s/[ @]*$//;
	return $string;
}

#--------------------------------------------------------------------
# 擾
#   `    $result = &Now;
#   ߂l  yyyy/mm/dd hh:mm:ss `̌ݓ
#--------------------------------------------------------------------
sub Now {
	package Now;
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime( time );
	$year += 1900 if ( $year < 1900 );
	$ymdhms = sprintf("%4d/%2d/%2d_%2d:%2d:%2d",$year, $mon + 1, $mday, $hour, $min, $sec);
	$ymdhms =~ tr/ _/0 /;
	return $ymdhms;
}
